<?php

require_once("xml-generator.php");
require_once("grouptags.inc.php");
require_once("related-tags.php");


function spicynodes_navigator_actions_save_post($postId=null, $arg2='') {
	$post = get_post($postId);
	if ($post->post_status == "publish") {
		//for home page
		spicynodes_navigator_remake_xml();
		
		//for post
		spicynodes_navigator_make_xml_4_post($postId, true);
		
		//for related tags
		spicynodes_navigator_make_related_tags_weight_4_post($postId);
	} else {
		$path = SpicyNodes_FileRoot;
		$f = "$path/xml/navigator-post-${postId}.xml";
		if (file_exists("$f")) {
			@unlink($f);
		}
	}
	spicynodes_navigator_clear_related_tags_4_post($postId); #to force tag re-generation
}

function spicynodes_navigator_actions_delete_post($postId=null, $arg2='') {
	spicynodes_navigator_clear_related_tags_4_post($postId);
	
	spicynodes_navigator_remake_xml();
	
	$path = SpicyNodes_FileRoot;
	$f = "$path/xml/navigator-post-${postId}.xml";
	if (file_exists("$f")) {
		@unlink($f);
	}
}

function spicynodes_navigator_actions_save_tag($tagId=nul, $arg2='') {
	spicynodes_navigator_make_tag_xml();
	spicynodes_navigator_make_xml_4_tag($tagId, true);
}

function spicynodes_navigator_actions_delete_tag($tagId=nul, $arg2='') {
	spicynodes_navigator_clear_related_tags_4_tag($tagId);
	
	spicynodes_navigator_make_tag_xml();
	
	$path = SpicyNodes_FileRoot;
	$f = "$path/xml/navigator-tag-${tagId}.xml";
	if (file_exists("$f")) {
		@unlink($f);
	}
}

function spicynodes_navigator_install() {
	spicynodes_navigator_relatedtags_create_tables();
	spicynodes_navigator_grouptags_create_tables();
	spicynodes_navigator_related_posts_create_tables();
	
	spicynodes_navigator_remake_all_related_tags_weight();
}

function spicynodes_navigator_register_action()
{
	global $wp_taxonomies;
	
	$options = get_option('spicynodes_navigator');
	$archive = htmlspecialchars($options['archive'], ENT_QUOTES);
	$category = htmlspecialchars($options['category'], ENT_QUOTES);
	$tag = htmlspecialchars($options['tag'], ENT_QUOTES);
	
	$has_archive = ("checked" == $archive);
	$has_category = ("checked" == $category);
	$has_tag = ("checked" == $tag);
	
	foreach( $wp_taxonomies as $taxonomy => $taxonomies ) {
		if ( $has_tag && (strpos($taxonomy,"tag")!==false) ) {
			$action = 'created_' . $taxonomy;
			add_action( $action, 'spicynodes_navigator_actions_save_tag', 10, 2 );
			$action = 'edit_' . $taxonomy;
			add_action( $action, 'spicynodes_navigator_actions_save_tag', 10, 2 );
			$action = 'delete_' . $taxonomy;
			add_action( $action, 'spicynodes_navigator_actions_delete_tag', 10, 2 );
		} elseif ( $has_category && (strpos($taxonomy,"category")!==false) ) {
			$action = 'created_' . $taxonomy;
			add_action( $action, 'spicynodes_navigator_make_category_xml' );
			$action = 'edit_' . $taxonomy;
			add_action( $action, 'spicynodes_navigator_make_category_xml' );
			$action = 'delete_' . $taxonomy;
			add_action( $action, 'spicynodes_navigator_make_category_xml' );
		}
	}
	if ($has_archive) {
		$action = 'transition_post_status';
		add_action( $action, 'spicynodes_navigator_make_archive_xml' );		
	}
	
	$action = 'delete_post';
	add_action( $action, 'spicynodes_navigator_actions_delete_post', 10, 2 );	
	$action = 'save_post';
	add_action( $action, 'spicynodes_navigator_actions_save_post', 10, 2 );		
}

//others actions

// [spicynodes id="0123456789abcdef0123456789abcdef" width="400" height="300"]
function spicynodes_navigator_shortcode($atts) {
	extract(shortcode_atts(array(
		'id' => 'nosuchid',
		'width' => '480',
		'height' => '360'
	), $atts));

	$s = <<<END
	<div>
	<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"
codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/
swflash.cab" height="$height" width="$width">
    <param name="movie" value="http://media.spicynodes.org/display.swf?id=$id">
    <param name="quality" value="high">
    <param name="allowFullScreen" value="true">
    <embed height="$height" width="$width" pluginspage="http://www.macromedia.com/go/getflashplayer"
src="http://media.spicynodes.org/display.swf?id=$id" type="application/x-shockwave-flash" quality="high" allowFullScreen="true">
  </object>
  </div>
END;

	return $s;
}

function spicynodes_navigator_add_meta() {
	$pageURL = 'http';
	if ($_SERVER["HTTPS"] == "on") {
		$pageURL .= "s";
		}
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"];
	} else {
		$pageURL .= $_SERVER["SERVER_NAME"];
	}
	$p = SpicyNodes_FileRoot;
	$p = substr($p, strlen($_SERVER['DOCUMENT_ROOT']));
	$href = $pageURL.$p."/zip/home.zip";
	
	echo "<link rel=\"nodemap\" href=\"$href\" />\n";
}

add_shortcode('spicynodes', 'spicynodes_navigator_shortcode');
add_action('wp_head', 'spicynodes_navigator_add_meta',99);

?>