<?php

# This file and files under "./lang" sub-direcotry are adapted:
#   from Yet Another Related Posts Plugin (http://mitcho.com/code/yarpp/)
#   by mitcho (Michael Yoshitaka Erlewine)

define (yarpp_keyword_cache, 'spicynodes_navigator_yarpp_keyword_cache');
define (yarpp_related_cache, 'spicynodes_navigator_yarpp_related_cache');


//keywords

function spicynodes_navigator_word_file_lang() {
	if (!defined('WPLANG'))
		return 'en_US';
	switch (true) {
		case preg_match("/^de/i",WPLANG):
			return 'de_DE';
		case preg_match("/^it/i",WPLANG):
			return 'it_IT';
		case preg_match("/^pl/i",WPLANG):
			return 'pl_PL';
		default:
			return 'en_US';
	}
}

function spicynodes_navigator_yarpp_extract_keywords($source,$max = 20) {
	include(SpicyNodes_FileRoot.'/include/lang/words-'.spicynodes_navigator_word_file_lang().'.php');

	#global $spicynodes_navigator_overusedwords;
	if (function_exists('mb_split')) {
		mb_regex_encoding(get_option('blog_charset'));
		$wordlist = mb_split('\s*\W+\s*', mb_strtolower($source));
	} else
		$wordlist = preg_split('%\s*\W+\s*%', strtolower($source));	

	// Build an array of the unique words and number of times they occur.
	$tokens = array_count_values($wordlist);
	
	// Remove the stop words from the list.
	foreach ($spicynodes_navigator_overusedwords as $word) {
		 unset($tokens[$word]);
	}
	// Remove words which are only a letter
	foreach (array_keys($tokens) as $word) {
		if (function_exists('mb_strlen'))
			if (mb_strlen($word) < 2) unset($tokens[$word]);
		else
			if (strlen($word) < 2) unset($tokens[$word]);
	}
	
	arsort($tokens, SORT_NUMERIC);
	
	$types = array_keys($tokens);
	
	if (count($types) > $max)
		$types = array_slice($types, 0, $max);
	return implode(' ', $types);
}

function spicynodes_navigator_post_title_keywords($ID,$max = 20) {
	global $wpdb;
	return spicynodes_navigator_yarpp_extract_keywords(spicynodes_navigator_html_entity_strip($wpdb->get_var("select post_title from $wpdb->posts where ID = $ID")),$max);
}

function spicynodes_navigator_html_entity_strip($html) {
	$html = preg_replace('/&#x[0-9a-f]+;/','',$html);
	$html = preg_replace('/&#[0-9]+;/','',$html);
	$html = preg_replace('/&[a-zA-Z]+;/','',$html);
	return $html;
}
/*
function spicynodes_navigator_apply_filters_if_white($tag, $value) {
	global $wp_filter, $merged_filters, $wp_current_filter;

	$args = array();
	$wp_current_filter[] = $tag;

	// Do 'all' actions first
	if ( isset($wp_filter['all']) ) {
		$args = func_get_args();
		_wp_call_all_hook($args);
	}

	if ( !isset($wp_filter[$tag]) ) {
		array_pop($wp_current_filter);
		return $value;
	}

	// Sort
	if ( !isset( $merged_filters[ $tag ] ) ) {
		ksort($wp_filter[$tag]);
		$merged_filters[ $tag ] = true;
	}

	reset( $wp_filter[ $tag ] );

	if ( empty($args) )
		$args = func_get_args();


	do{
		foreach( (array) current($wp_filter[$tag]) as $the_ ) {
			if ( !is_null($the_['function'])
			and spicynodes_navigator_yarpp_white($the_['function'])){ // HACK
				$args[1] = $value;
				$value = call_user_func_array($the_['function'], array_slice($args, 1, (int) $the_['accepted_args']));
			}
		}

	} while ( next($wp_filter[$tag]) !== false );

	array_pop( $wp_current_filter );

	return $value;
}
*/
function spicynodes_navigator_post_body_keywords($ID,$max = 20) {
	global $wpdb;
	//$content = strip_tags(spicynodes_navigator_apply_filters_if_white('the_content',$wpdb->get_var("select post_content from $wpdb->posts where ID = $ID")));
	$content = strip_tags($wpdb->get_var("select post_content from $wpdb->posts where ID = $ID"));
	$content = spicynodes_navigator_html_entity_strip($content);
	return spicynodes_navigator_yarpp_extract_keywords($content,$max);
}
/*
function spicynodes_navigator_yarpp_white($filter) {
	$spicynodes_navigator_yarpp_blacklist = array(null,'yarpp_default','diggZEt_AddBut','reddZEt_AddBut','dzoneZEt_AddBut','wp_syntax_before_filter','wp_syntax_after_filter','wp_codebox_before_filter','wp_codebox_after_filter','do_shortcode');//,'insert_tweet_this'
	$spicynodes_navigator_yarpp_blackmethods = array(null,'addinlinejs','replacebbcode','filter_content');

	if (is_array($filter)) {
		if (array_search($filter[1],$spicynodes_navigator_yarpp_blackmethods)) //print_r($filter[1]);
			return false;
	}
	if (array_search($filter,$spicynodes_navigator_yarpp_blacklist)) //print_r($filter);
		return false;
	return true;
}
*/
function spicynodes_navigator_yarpp_cache_keywords($ID) {
	global $wpdb;
    $body_terms = spicynodes_navigator_post_body_keywords($ID);
    $title_terms = spicynodes_navigator_post_title_keywords($ID);
	
	if (defined('DB_CHARSET') && DB_CHARSET) {
  	$wpdb->query('set names '.DB_CHARSET);
	}
	
	$wpdb->query("insert into {$wpdb->prefix}".yarpp_keyword_cache." (ID,body,title) values ($ID,'$body_terms ','$title_terms ') on duplicate key update date = now(), body = '$body_terms ', title = '$title_terms '");
	
}

function spicynodes_navigator_yarpp_get_cached_keywords($ID,$type='body') {
	global $wpdb;
	$out = $wpdb->get_var("select $type from {$wpdb->prefix}".yarpp_keyword_cache." where ID = $ID");
	if ($out === false or $out == '') { // if empty, try caching them first.
		spicynodes_navigator_yarpp_cache_keywords($ID);
    $out = $wpdb->get_var("select $type from {$wpdb->prefix}".yarpp_keyword_cache." where ID = $ID");
  }
	if ($out === false or $out == '') { // if still empty... return false
		//echo "<!--YARPP ERROR: couldn't select/create yarpp $type keywords for $ID-->";
    return false;
	} else {
		return $out;
  }
}

// replacement html_entity_decode code from php.net
// author: laurynas dot butkus at gmail dot com

function spicynodes_navigator_html_entity_decode_utf8($string) {
    static $trans_tbl;
    
    // replace numeric entities
    $string = preg_replace('~&#x([0-9a-f]+);~ei', 'spicynodes_navigator_code2utf(hexdec("\\1"))', $string);
    $string = preg_replace('~&#([0-9]+);~e', 'spicynodes_navigator_code2utf(\\1)', $string);

    // replace literal entities
    if (!isset($trans_tbl))
    {
        $trans_tbl = array();
        
        foreach (get_html_translation_table(HTML_ENTITIES) as $val=>$key)
            $trans_tbl[$key] = utf8_encode($val);
    }
    
    return strtr($string, $trans_tbl);
}

// Returns the utf string corresponding to the unicode value (from php.net, courtesy - romans@void.lv)
function spicynodes_navigator_code2utf($num)
{
    if ($num < 128) return chr($num);
    if ($num < 2048) return chr(($num >> 6) + 192) . chr(($num & 63) + 128);
    if ($num < 65536) return chr(($num >> 12) + 224) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
    if ($num < 2097152) return chr(($num >> 18) + 240) . chr((($num >> 12) & 63) + 128) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
    return '';
}

//related posts
function spicynodes_navigator_yarpp_sql($type,$args,$giveresults = true,$reference_ID=false,$domain='website') {
	global $wpdb, $post;

	if (is_object($post) and !$reference_ID) {
		$reference_ID = $post->ID;
	}
	
	// set the "domain prefix", used for all the preferences.
	if ($domain == 'rss')
		$domainprefix = 'rss_';
	else
		$domainprefix = '';

	$optvals = array('limit'=>5,
		'threshold'=>5,
		'show_pass_post'=>'',
		'past_only'=>1,
		'cross_relate'=>'',
		'body'=>2,
		'title'=>2,
		'tags'=>2,
		'categories'=>2,
		'distags'=>'',
		'discats'=>'',
		'recent_only'=>'',
		'recent_number'=>12,
		'recent_units'=>'month');

	/*
	$optvals = array();
	foreach (array_keys($options) as $option) {
		if (isset($args[$option])) {
			$optvals[$option] = stripslashes($args[$option]);
		} else {
			$optvals[$option] = stripslashes(stripslashes(yarpp_get_option($options[$option])));
		}
	}
	*/

	extract($optvals);

	// Fetch keywords
    $body_terms = spicynodes_navigator_yarpp_get_cached_keywords($reference_ID,'body');
    $title_terms = spicynodes_navigator_yarpp_get_cached_keywords($reference_ID,'title');
    
	// get weights
	
	$bodyweight = (($body == 3)?3:(($body == 2)?1:0));
	$titleweight = (($title == 3)?3:(($title == 2)?1:0));
	$tagweight = (($tags != 1)?1:0);
	$catweight = (($categories != 1)?1:0);
	$weights = array();
	$weights['body'] = $bodyweight;
	$weights['title'] = $titleweight;
	$weights['cat'] = $catweight;
	$weights['tag'] = $tagweight;
	
	$totalweight = $bodyweight + $titleweight + $tagweight + $catweight;
	
	// get disallowed categories and tags
	
	$disterms = implode(',', array_filter(array_merge(explode(',',$discats),explode(',',$distags)),'is_numeric'));

	$usedisterms = count(array_filter(array_merge(explode(',',$discats),explode(',',$distags)),'is_numeric'));

	$criteria = array();
	if ($bodyweight)
		$criteria['body'] = "(MATCH (post_content) AGAINST ('".$wpdb->escape($body_terms)."'))";
	if ($titleweight)
		$criteria['title'] = "(MATCH (post_title) AGAINST ('".$wpdb->escape($title_terms)."'))";
	if ($tagweight)
		$criteria['tag'] = "COUNT( DISTINCT tagtax.term_taxonomy_id )";
	if ($catweight)
		$criteria['cat'] = "COUNT( DISTINCT cattax.term_taxonomy_id )";

	$newsql = "SELECT $reference_ID, ID, "; //post_title, post_date, post_content, post_excerpt, 

	//foreach ($criteria as $key => $value) {
	//	$newsql .= "$value as ${key}score, ";
	//}

	$newsql .= '(0';
	foreach ($criteria as $key => $value) {
		$newsql .= "+ $value * ".$weights[$key];
	}
	$newsql .= ') as score';
	
	$newsql .= "\n from $wpdb->posts \n";

	if ($usedisterms)
		$newsql .= " left join $wpdb->term_relationships as blockrel on ($wpdb->posts.ID = blockrel.object_id)
		left join $wpdb->term_taxonomy as blocktax using (`term_taxonomy_id`)
		left join $wpdb->terms as blockterm on (blocktax.term_id = blockterm.term_id and blockterm.term_id in ($disterms))\n";

	if ($tagweight)
		$newsql .= " left JOIN $wpdb->term_relationships AS thistag ON (thistag.object_id = $reference_ID ) 
		left JOIN $wpdb->term_relationships AS tagrel on (tagrel.term_taxonomy_id = thistag.term_taxonomy_id
		AND tagrel.object_id = $wpdb->posts.ID)
		left JOIN $wpdb->term_taxonomy AS tagtax ON ( tagrel.term_taxonomy_id = tagtax.term_taxonomy_id
		AND tagtax.taxonomy = 'post_tag')\n";

	if ($catweight)
		$newsql .= " left JOIN $wpdb->term_relationships AS thiscat ON (thiscat.object_id = $reference_ID ) 
		left JOIN $wpdb->term_relationships AS catrel on (catrel.term_taxonomy_id = thiscat.term_taxonomy_id
		AND catrel.object_id = $wpdb->posts.ID)
		left JOIN $wpdb->term_taxonomy AS cattax ON ( catrel.term_taxonomy_id = cattax.term_taxonomy_id
		AND cattax.taxonomy = 'category')\n";

	// WHERE
	
	$newsql .= " where (post_status IN ( 'publish',  'static' ) and ID != '$reference_ID')";

	if ($past_only) { // 3.1.8: revised $past_only option
    if ( is_object($post) && $reference_ID == $post->ID )
	    $reference_post_date = $post->post_date;
	  else
	    $reference_post_date = $wpdb->get_var("select post_date from $wpdb->posts where ID = $reference_ID");
		$newsql .= " and post_date <= '$reference_post_date' ";
	}
	if (!$show_pass_post)
		$newsql .= " and post_password ='' ";
	if ($recent_only)
		$newsql .= " and post_date > date_sub(now(), interval $recent_number $recent_units) ";

  if ($type == array('page') && !$cross_relate)
    $newsql .= " and post_type = 'page'";
  else
    $newsql .= " and post_type = 'post'";

	// GROUP BY
	$newsql .= "\n group by id \n";
	// HAVING
	// safethreshold is so the new calibration system works.
	// number_format fix suggested by vkovalcik! :) 
	$safethreshold = number_format(max($threshold,0.1), 2, '.', '');
	$newsql .= " having score >= $safethreshold";
	if ($usedisterms)
		$newsql .= " and count(blockterm.term_id) = 0";

	$newsql .= (($categories == 3)?' and '.$criteria['cat'].' >= 1':'');
	$newsql .= (($categories == 4)?' and '.$criteria['cat'].' >= 2':'');
	$newsql .= (($tags == 3)?' and '.$criteria['tag'].' >= 1':'');
	$newsql .= (($tags == 4)?' and '.$criteria['tag'].' >= 2':'');
	$newsql .= " order by score desc limit ".$limit;

	if (!$giveresults) {
		$newsql = "select count(t.ID) from ($newsql) as t";
	}

  // if we're looking for a X related entries, make sure we get at most X posts and X pages if
  // we cross-relate
	if ($cross_relate) $newsql = "($newsql) union (".str_replace("post_type = 'post'","post_type = 'page'",$newsql).")";

	return $newsql;
}

function spicynodes_navigator_yarpp_save_cache($post_ID,$force=true) {
	global $wpdb;

  $sql = "select post_parent, post_type from $wpdb->posts where ID='$post_ID'";
	$parent_ID = $wpdb->get_var($sql,0);

	if ($parent_ID != $post_ID and $parent_ID)
		$post_ID = $parent_ID;

	# FOR SIMPLIFICATION: no cross_related
	/*
	$post_type = $wpdb->get_var($sql,1);
	if (yarpp_get_option('cross_relate'))
		$type = array('post','page');
	elseif ($post_type == 'page')
		$type = array('page');
	else
		$type = array('post');
  // TODO: support other post types? maybe?
  // TODO: fix this bug... we should be getting the post type from the parent, if there is one.
  */
	$type = array('post');
	
  spicynodes_navigator_yarpp_cache_enforce($type,$post_ID,$force);	
}

function spicynodes_navigator_yarpp_cache_clear($reference_IDs) {
  global $wpdb;
  if (is_array($reference_IDs) && count($reference_IDs)) {
    $wpdb->query("delete from {$wpdb->prefix}".yarpp_related_cache." where reference_ID in (".implode(',',$reference_IDs).")");
  }
}

function spicynodes_navigator_yarpp_cache_enforce($type=array('post'),$reference_ID,$force=false) {
	global $wpdb;
	
	if ($reference_ID === '' || $reference_ID === false)
	  return false;
	
	if (!$force) {
		if ($wpdb->get_var("select count(*) as count from {$wpdb->prefix}".yarpp_related_cache." where reference_ID = $reference_ID")) {
      // 3.1.3: removed the cache timeout
      // and date > date_sub(now(),interval 600 minute)
			return false;
		}
	}
	
	spicynodes_navigator_yarpp_cache_keywords($reference_ID);
	
	// clear out the cruft
  spicynodes_navigator_yarpp_cache_clear(array($reference_ID));
	
	// let's update the related posts
	$wpdb->query("insert into {$wpdb->prefix}".yarpp_related_cache." (reference_ID,ID,score) ".spicynodes_navigator_yarpp_sql($type,array(),true,$reference_ID)." on duplicate key update date = now()");
	
	$affected = $wpdb->rows_affected;
	
	// if changes were made, let's find out which ones are new. We'll want to clear their caches
	// so that they will be rebuilt when they're hit next.
	/* past_only = 1 by default
	if ($affected && !yarpp_get_option('past_only')) {
		$new_relations = $wpdb->get_col("select ID from {$wpdb->prefix}".yarpp_related_cache." where reference_ID = $reference_ID and ID != 0");
		spicynodes_navigator_yarpp_cache_clear($new_relations);
	}
	*/
	if ($affected) { //ignore past_only
		$new_relations = $wpdb->get_col("select ID from {$wpdb->prefix}".yarpp_related_cache." where reference_ID = $reference_ID and ID != 0");
		spicynodes_navigator_yarpp_cache_clear($new_relations);
	}
	
	if (!$affected) {
		$wpdb->query("insert into {$wpdb->prefix}".yarpp_related_cache." (reference_ID,ID,score) values ($reference_ID,0,0) on duplicate key update date = now()");
		if (!$wpdb->rows_affected)
			return false;
	}
	
	return true;
	
}

function spicynodes_navigator_related_posts_create_tables() {

	global $wpdb;
	/*
	if (!$wpdb->query("ALTER TABLE $wpdb->posts ADD FULLTEXT `yarpp_title` ( `post_title`)")) {
		echo "<!--".__('MySQL error on adding yarpp_title','yarpp').": ";
		$wpdb->print_error();
		echo "-->";
	}
	if (!$wpdb->query("ALTER TABLE $wpdb->posts ADD FULLTEXT `yarpp_content` ( `post_content`)")) {
		echo "<!--".__('MySQL error on adding yarpp_content','yarpp').": ";
		$wpdb->print_error();
		echo "-->";
	}
	*/
	$table_name = $wpdb->prefix.yarpp_keyword_cache;
	$wpdb->query("DROP TABLE IF EXISTS $table_name;");
	if (!$wpdb->query("CREATE TABLE $table_name (
		`ID` bigint(20) unsigned NOT NULL default '0',
		`body` text collate utf8_unicode_ci NOT NULL,
		`title` text collate utf8_unicode_ci NOT NULL,
		`date` timestamp NOT NULL default CURRENT_TIMESTAMP,
		PRIMARY KEY  (`ID`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='YARPP''s keyword cache table';")) {
		/*
		echo "<!--".__('MySQL error on creating yarpp_keyword_cache table','yarpp').": ";
		$wpdb->print_error();
		echo "-->";
		*/
		;
	}
	$table_name = $wpdb->prefix.yarpp_related_cache;
	$wpdb->query("DROP TABLE IF EXISTS $table_name;");
	if (!$wpdb->query("CREATE TABLE $table_name (
		`reference_ID` bigint(20) unsigned NOT NULL default '0',
		`ID` bigint(20) unsigned NOT NULL default '0',
		`score` float unsigned NOT NULL default '0',
		`date` timestamp NOT NULL default CURRENT_TIMESTAMP,
		PRIMARY KEY ( `score` , `date` , `reference_ID` , `ID` )
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;")) {
		/*
		echo "<!--".__('MySQL error on creating yarpp_related_cache table','yarpp').": ";
		$wpdb->print_error();
		echo "-->";
		*/
		;
	}
}

//
/* new in 3.0! new query-based approach: EXTREMELY HACKY! */

function spicynodes_navigator_yarpp_related_posts($reference_ID) {
	//global $wpdb, $post, $userdata, $spicynodes_navigator_yarpp_time, $spicynodes_navigator_yarpp_demo_time, $wp_query, $id, $page, $pages, $authordata, $day, $currentmonth, $multipage, $more, $numpages;
	global $wpdb;
	
	$related_postids = $wpdb->get_col("select ID from {$wpdb->prefix}".yarpp_related_cache." where reference_ID = $reference_ID and ID != 0 ORDER BY score DESC");
	return $related_postids;
}

//customed
function spicynodes_navigator_yarpp_cache_clear_all() {
	global $wpdb;
	$wpdb->query("DELETE FROM {$wpdb->prefix}".yarpp_keyword_cache);
	$wpdb->query("DELETE FROM {$wpdb->prefix}".yarpp_related_cache);
}

function spicynodes_navigator_yarpp_remake_all_related_posts() {
	spicynodes_navigator_yarpp_cache_clear_all();
	
	$args = array(
		'post_type' => 'post',
		'numberposts' => -1
	);
	$posts = get_posts($args);
	if ($posts) {
		foreach ($posts as $p) {
			if ($p->post_status == "publish") {
				spicynodes_navigator_yarpp_cache_keywords($p->ID);
			}
		}
		foreach ($posts as $p) {
			if ($p->post_status == "publish") {
				spicynodes_navigator_yarpp_save_cache($p->ID);
			}
		}
	}
}

?>
