<?php

define ("WEIGHT_INC", 5);
define ("WEIGHT_INC_RELATEDTAG", 2);


require_once("related-posts.php");


function spicynodes_navigator_make_related_tags_weight_4_post($postID) {
	spicynodes_navigator_yarpp_save_cache($postID);
	spicynodes_navigator_make_related_tags_weight_4_posti($postID);
}

function spicynodes_navigator_make_related_tags_weight_4_posti($postID) {
	global $wpdb;
	$table_name = "{$wpdb->prefix}spicynodes_navigator_tags_weight";
	$wpdb->query( $wpdb->prepare( "DELETE FROM ${table_name} WHERE post_id = %d", $postID) );
	
	$tags = get_the_tags($postID);
	if ($tags) {
		
		foreach ($tags as $tag) {
			foreach ($tags as $tag2) {
				$tid = $tag->term_id;
				$tid2 = $tag2->term_id;
				if ($tid != $tid2) {
					$weight = $wpdb->get_var($wpdb->prepare("SELECT weight FROM ${table_name} WHERE post_id = %d AND tag_id = %d AND related_tag_id = %d", array($postID, $tid, $tid2)));
					if ($weight) {
						$weight += WEIGHT_INC;
						$wpdb->query( $wpdb->prepare( "UPDATE ${table_name} SET weight = %d WHERE post_id=%d AND tag_id=%d AND related_tag_id= %d", array($weight, $postID, $tid, $tid2)) );
					} else {
						$weight = WEIGHT_INC;
						$wpdb->query( $wpdb->prepare( "INSERT INTO ${table_name} ( post_id, tag_id, related_tag_id, weight ) VALUES ( %d, %d, %d, %d )", array($postID, $tid, $tid2, $weight)));
					}
				}
			}
		}
		
		//do for related $tags
		$postids = spicynodes_navigator_yarpp_related_posts($postID);
		if ($postids) {
			foreach ($postids as $pid) {
				$tags2 = get_the_tags($pid);
				if ($tags2) {
					foreach ($tags as $tag) {
						foreach ($tags2 as $tag2) {
							$tid = $tag->term_id;
							$tid2 = $tag2->term_id;
							if ($tid != $tid2) {
								$weight = $wpdb->get_var($wpdb->prepare("SELECT weight FROM ${table_name} WHERE $post_id=%d AND tag_id = %d AND related_tag_id = %d", array($postID, $tid, $tid2)));
								if ($weight) {
									$weight += WEIGHT_INC_RELATEDTAG;
									$wpdb->query( $wpdb->prepare( "UPDATE ${table_name} SET weight = %d WHERE post_id=%d tag_id=%d AND related_tag_id= %d", array($weight, $postID, $tid, $tid2)) );
								} else {
									$weight = WEIGHT_INC_RELATEDTAG;
									$wpdb->query( $wpdb->prepare( "INSERT INTO ${table_name} ( post_id, tag_id, related_tag_id, weight ) VALUES ( %d, %d, %d, %d )", array($postID, $tid, $tid2, $weight)));
								}
							}
						}
					}
				}
			}
		}
	}
}

function spicynodes_navigator_get_related_tags($tag_id) {
	global $wpdb;
	$table_name = "{$wpdb->prefix}spicynodes_navigator_tags_weight";
	$rows = $wpdb->get_results($wpdb->prepare("SELECT related_tag_id, weight FROM ${table_name} WHERE tag_id = %d ORDER BY weight DESC", $tag_id));
	if ($rows) {
		foreach ($rows as $row) {
			$related_ids[$row->related_tag_id] += $row->weight;
		}
		arsort($related_ids);
		$related_ids = array_keys($related_ids);
	}
			
	return $related_ids;
}

function spicynodes_navigator_clear_related_tags_4_post($postId) {
	if ($postId) {
		global $wpdb;
		$table_name = "{$wpdb->prefix}spicynodes_navigator_tags_weight";
		$wpdb->prepare("DELETE FROM ${table_name} WHERE post_id = %d", $postId);
		spicynodes_navigator_yarpp_cache_clear(array($postId));
	}
	
	//delete all associaated tag xml file
	$tags = get_the_tags($postId);
	if ($tags) {
		$path = SpicyNodes_FileRoot;
		foreach ($tags as $tag) {
			$tagId = $tag->term_id;
			$f = "$path/xml/navigator-tag-${tagId}.xml";
			if (file_exists("$f")) {
				@unlink($f);
			}
		}
	}
}

function spicynodes_navigator_clear_related_tags_4_tag($tagId) {
	if ($tagId) {
		global $wpdb;
		$table_name = "{$wpdb->prefix}spicynodes_navigator_tags_weight";
		$wpdb->query( $wpdb->prepare("DELETE FROM ${table_name} WHERE tag_id = %d OR related_tag_id = %d", array($tagId, $tagId)) );
	}
}

function spicynodes_navigator_clear_related_tags_all() {
	global $wpdb;
	$table_name = "{$wpdb->prefix}spicynodes_navigator_tags_weight";
	$wpdb->query( $wpdb->prepare("DELETE FROM ${table_name}") );
}

function spicynodes_navigator_remake_all_related_tags_weight() {
	
	spicynodes_navigator_yarpp_remake_all_related_posts();
	
	//
	spicynodes_navigator_clear_related_tags_all();
	$args = array(
		'post_type' => 'post',
		'numberposts' => -1
	);
	$posts = get_posts($args);
	if ($posts) {
		foreach ($posts as $p) {
			if ($p->post_status == "publish") {
				spicynodes_navigator_make_related_tags_weight_4_posti($p->ID);
			}
		}
	}
}

function spicynodes_navigator_relatedtags_create_tables() {
	global $wpdb;
	
	//for tags weight
	$table_name = "{$wpdb->prefix}spicynodes_navigator_tags_weight";
	$wpdb->query("DROP TABLE IF EXISTS $table_name;");
	$wpdb->query("CREATE TABLE $table_name (
		tags_weight_id bigint(20) unsigned NOT NULL auto_increment,
		post_id bigint(20) unsigned NOT NULL default 0,
		tag_id bigint(20) unsigned NOT NULL default 0,
		related_tag_id bigint(20) unsigned NOT NULL default 0,
		weight int(4) unsigned NOT NULL default 0,
		PRIMARY KEY  (tags_weight_id),
		KEY tag_id (tag_id)
		)  ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;");
}

?>