<?php

define ("SpicyNodes_PerOrbit", 6);

require_once("related-tags.php");
require_once("grouptags.inc.php");


function spicynodes_navigator_make_settings_xml()
{
	$options = get_option('spicynodes_navigator');
	
	$bkgcolor = "0x".htmlspecialchars($options['bkgcolor'], ENT_QUOTES);
	$nodecolor = "0x".htmlspecialchars($options['nodecolor'], ENT_QUOTES);
	$textcolor = "0x".htmlspecialchars($options['textcolor'], ENT_QUOTES);
	$language = htmlspecialchars($options['language'], ENT_QUOTES);
	
	$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Zoom]]></zoom>
			<focus value="true"><![CDATA[Focus]]></focus>
			<search value="false"><![CDATA[Search]]></search>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[Previous]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[Next]]></next>
			<home key="h" value="true"><![CDATA[Home]]></home>
			<help key="?h" value="true"><![CDATA[Help]]></help>
			<volume value="false"><![CDATA[Volume]]></volume>
			<fullscreen key="f" value="true"><![CDATA[Full screen]]></fullscreen>
		</widgets>
		<messages>
			<searchnone><![CDATA[Sorry, there are no results for this query]]></searchnone>
			<zoom><![CDATA[Overall zoom level]]></zoom>
			<focus><![CDATA[Relative size of current node vs. surroundings]]></focus>
			<volume><![CDATA[Adjust volume level]]></volume>
			<volumeoff><![CDATA[Mute all sounds]]></volumeoff>
		</messages>
END;

	if ("es" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Ampliar]]></zoom>
			<focus value="true"><![CDATA[Enfoque]]></focus>
			<search value="false"><![CDATA[Buscar]]></search>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[Anterior]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[Siguiente]]></next>
			<home key="h" value="true"><![CDATA[Inicio]]></home>
			<help key="?h" value="true"><![CDATA[Ayuda]]></help>
			<volume value="false"><![CDATA[Sonido]]></volume>
			<fullscreen key="f" value="true"><![CDATA[Pantalla completa]]></fullscreen>
		</widgets>
		<messages>
			<searchnone><![CDATA[Lo siento, no hay nodos que coincidan con su búsqueda]]></searchnone>
			<zoom><![CDATA[Este es un aumento general de la pantalla]]></zoom>
			<focus><![CDATA[Este es el tamaño relativo del nodo central vs. el entorno]]></focus>
			<volume><![CDATA[Este es el control de volumen]]></volume>
			<volumeoff><![CDATA[Apagar sonido]]></volumeoff>
		</messages>
END;
	} elseif ("fr" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Zoom]]></zoom>
			<focus value="true"><![CDATA[Focus]]></focus>
			<search value="false"><![CDATA[Recherche]]></search>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[Précédent]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[Suivant]]></next>
			<home key="h" value="true"><![CDATA[Accueil]]></home>
			<help key="?h" value="true"><![CDATA[Aide]]></help>
			<volume value="false"><![CDATA[Son]]></volume>
			<fullscreen key="f" value="true"><![CDATA[Plein écran]]></fullscreen>
		</widgets>
		<messages>
			<searchnone><![CDATA[Désolés, aucun nœud ne correspond à votre recherche]]></searchnone>
			<zoom><![CDATA[Agrandissement total de l’écran]]></zoom>
			<focus><![CDATA[il s’agit de la taille relative du noeud]]></focus>
			<volume><![CDATA[Contrôle du volume]]></volume>
			<volumeoff><![CDATA[Couper le son]]></volumeoff>
		</messages>
END;
	} elseif ("pt" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Aumentar]]></zoom>
			<search value="false"><![CDATA[Procurar]]></search>
			<focus value="true"><![CDATA[Focar]]></focus>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[Anterior]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[Seguinte]]></next>
			<home key="h" value="true"><![CDATA[Início]]></home>
			<fullscreen key="f" value="true"><![CDATA[Ecrã inteiro]]></fullscreen>
			<volume value="false"><![CDATA[Som]]></volume>
			<help key="?h" value="true"><![CDATA[Ajuda]]></help>			
		</widgets>
		<messages>
			<searchnone><![CDATA[Infelizmente a sua pesquisa não teve resultados]]></searchnone>
			<zoom><![CDATA[Overall zoom level]]></zoom>
			<focus><![CDATA[Relative size of current node vs. surroundings]]></focus>
			<volume><![CDATA[Adjust volume level]]></volume>
			<volumeoff><![CDATA[Som desligado]]></volumeoff>
		</messages>
END;
	} elseif ("ru" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Размер]]></zoom>
			<search value="false"><![CDATA[Поиск]]></search>
			<focus value="true"><![CDATA[Фокус]]></focus>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[Назад]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[Вперед]]></next>
			<home key="h" value="true"><![CDATA[К началу]]></home>
			<fullscreen key="f" value="true"><![CDATA[На весь экран]]></fullscreen>
			<volume value="false"><![CDATA[Звук]]></volume>
			<help key="?h" value="true"><![CDATA[Помощь]]></help>			
		</widgets>
		<messages>
			<searchnone><![CDATA[К сожалению ничего не было найдено]]></searchnone>
			<zoom><![CDATA[Изменяет размер всех элементов на экране]]></zoom>
			<focus><![CDATA[Изменяет размер центрального элемента по отношению к окружающим]]></focus>
			<volume><![CDATA[Изменяет громкость звука]]></volume>
			<volumeoff><![CDATA[Без звука]]></volumeoff>
		</messages>
END;
	} elseif ("de" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Zoom]]></zoom>
			<search value="false"><![CDATA[Suche]]></search>
			<focus value="true"><![CDATA[Fokus]]></focus>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[zurück]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[weiter]]></next>
			<home key="h" value="true"><![CDATA[К Home]]></home>
			<fullscreen key="f" value="true"><![CDATA[Full screen]]></fullscreen>
			<volume value="false"><![CDATA[Ton]]></volume>
			<help key="?h" value="true"><![CDATA[Hilfe]]></help>			
		</widgets>
		<messages>
			<searchnone><![CDATA[Es konnten leider keine Ergebnisse gefunden werden]]></searchnone>
			<zoom><![CDATA[Diese Seite wird vergrößert dargestellt]]></zoom>
			<focus><![CDATA[Die Größe des Mittelpunktes der Grafik ist relativ zu den umliegenden Punkten surroundings]]></focus>
			<volume><![CDATA[Dies ist der Lautstärkeregler]]></volume>
			<volumeoff><![CDATA[Ton aus]]></volumeoff>
		</messages>
END;
	} elseif ("zh" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[缩放]]></zoom>
			<search value="false"><![CDATA[查找]]></search>
			<focus value="true"><![CDATA[聚焦]]></focus>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[上一级]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[下一级]]></next>
			<home key="h" value="true"><![CDATA[根节点]]></home>
			<fullscreen key="f" value="true"><![CDATA[全屏]]></fullscreen>
			<volume value="false"><![CDATA[音量]]></volume>
			<help key="?h" value="true"><![CDATA[帮助]]></help>			
		</widgets>
		<messages>
			<searchnone><![CDATA[对不起，没有匹配的结果]]></searchnone>
			<zoom><![CDATA[放大、缩小整个屏幕]]></zoom>
			<focus><![CDATA[突出显示当前节点]]></focus>
			<volume><![CDATA[音量调节]]></volume>
			<volumeoff><![CDATA[关闭声音]]></volumeoff>
		</messages>
END;
	} elseif ("pl" == $language) {
		$strings = <<<END
		<widgets>
			<zoom value="true"><![CDATA[Powiększ]]></zoom>
			<search value="false"><![CDATA[Szukaj]]></search>
			<focus value="true"><![CDATA[Skupienie]]></focus>
			<breadcrumbs value="false" />
			<previous key=":LEFT:" value="true"><![CDATA[Poprzedni]]></previous>
			<next key=":RIGHT:" value="true"><![CDATA[Następny]]></next>
			<home key="h" value="true"><![CDATA[Początek]]></home>
			<fullscreen key="f" value="true"><![CDATA[Cały ekran]]></fullscreen>
			<volume value="false"><![CDATA[Dźwięk]]></volume>
			<help key="?h" value="true"><![CDATA[Pomoc]]></help>			
		</widgets>
		<messages>
			<searchnone><![CDATA[Niestety, nie odnaleziono węzłów spełniających kryteria szukania]]></searchnone>
			<zoom><![CDATA[Ogólne powiększenie ekranu]]></zoom>
			<focus><![CDATA[Powiększenie węzła centralnego względem ekranu]]></focus>
			<volume><![CDATA[Reguluj poziom dźwięku]]></volume>
			<volumeoff><![CDATA[Wyłącz dźwięk]]></volumeoff>
		</messages>
END;
	}

	$xml = <<<END
<?xml version="1.0" ?>
<style>
	<metadata>
		<title>
		<![CDATA[undefined]]>
		</title>
		<generator value="SpicyNodes Style - Manually edited for WordPress" />
		<mtime value="1 September 2010" />
	</metadata>
	<text language="$language">
		<fonts>
		<font type="label" lang="en|es|fr|pt|de|pl|ru|zh" path="" size="16" src="Helvetica.swf" />
		<font type="label" lang="en|es|fr|pt|de|pl|ru|zh" path="" size="15" src="Helvetica.swf" />
		<font type="center" lang="en|es|fr|pt|de|pl|ru|zh" path="" size="19" src="Helvetica.swf" />
		<font type="center" lang="en|es|fr|pt|de|pl|ru|zh" path="" size="18" src="Helvetica.swf" />
		<font type="center" lang="en|es|fr|pt|de|pl|ru|zh" path="" size="17" src="Helvetica.swf" />
		</fonts>
	</text>
	<layout>
		<background />
		<orbits>
			<shape value="0.48" />
			<radius value="0.59" />
			<magnetic value="true" />
			<stagger value="true" />
			<maxorbitlevels value="1" />
		</orbits>
	</layout>
	<shapes>
		<center src="microsite_center.swf">
			<param id="0" value="1" name="Transparency" />
			<param id="1" value="0.66" name="Corners roundness" />
			<param id="2" value="0.11" name="Edges thickness" />
			<param id="3" value="0.63" name="Shadow" />
			<param id="4" value="0.2" name="Padding" />
		</center>
		<label src="spicynodes_labels.swf">
			<param id="0" value="0.7" name="Transparency" />
		</label>
		<connector src="spicynodes_connectors.swf">
			<param id="0" value="0.5" name="Transparency" />
			<param id="1" value="1" name="Length" />
			<param id="2" value="0.45" name="Thickness" />
			<param id="3" value="1" name="Bending" />
		</connector>
		<node src="microsite_nodes.swf">
			<param id="0" value="0.7905" name="Transparency" />
			<param id="1" value="0.41" name="Corners roundness" />
			<param id="2" value="0.1" name="Edges thickness" />
			<param id="3" value="0.19" name="Shadow" />
			<param id="4" value="0" name="Margin" />
			<param id="5" value="FALSE" name="Fading" />
			<param id="6" value="FALSE" name="Numbers" />
		</node>
	</shapes>
	<interaction>
		<audio>
			<audio name="null" />
		</audio>
		<more>
			<drag value="true" />
			<spin value="0.829" />
			<transition_speed value="0.7" />
			<use_expansion value="false" />
			<use_back_icon value="false" />
			<use_visited_icon value="false" />
		</more>
	</interaction>
	<navigation>
		<panels>
			<navpanel swf="microsite_panel.swf" />
			<position value="Bottom" />
			<autohide value="false" />
			<helppanel swf="microsite_help.swf" />
		</panels>
${strings}
		<center />
	</navigation>
	<colors>
		<color value="$bkgcolor" />
		<color value="$textcolor" />
		<color value="0x6988be" />
		<color value="0x69a4d7" />
		<color value="0xffffff" />
		<color value="0xc8c7cf" />
		<color value="0x4f8dc8" />
		<color value="$nodecolor" />
		<color value="0x999999" />
		<color value="0xa2a2a6" />
		<color value="0x6988be" />
		<color value="0xb080e4" />
		<color value="0x13e28e" />
		<color value="0xc7ef25" />
		<color value="0xcfcfcf" />
		<color value="0xbdbdbd" />
	</colors>
</style>
END;

	file_put_contents(SpicyNodes_FileRoot."/xml/settings.xml", $xml);
}

function spicynodes_navigator_make_tag_xmli($tags) {

	if ($tags) {		
		$i = 0;
		$j = 0;
		$NUM_EACH_LEVEL = SpicyNodes_PerOrbit;
		foreach ($tags as $tag){
			$tag_label = $tag->name; // ." (".$tag->count.")";
			$tag_link = get_tag_link($tag->term_id);
			//$id = str_pad((string)($tag->term_id), 32, "1", STR_PAD_LEFT);
			
			if ($i && 0 == ($i%$NUM_EACH_LEVEL)) {
				$s = $i+1;
				$xml .= "<node>\n";
				$xml .= "  <label>\n";
				$xml .= "  <![CDATA[MORE ($s...)]]>\n";
				$xml .= "  </label>\n";
				$j++;
			}
			
			#$xml .= "<node linktext='Show...' type='http' href='${tag_link}' id='${id}' >\n";
			$xml .= "<node linktext='Show...' type='http' href='${tag_link}' >\n";
			$xml .= "  <label>\n";
			$xml .= "  <![CDATA[${tag_label}]]>\n";
			$xml .= "  </label>\n";
			
			//require_once "navigator.inc.php";
			//$xml .= spicynodes_navigator_make_related_tags_xml($tag->term_id);
			
			$xml .= "</node>\n";
			
			$i++;
		}
		
		for (; $j>0; $j--) {
			$xml .= "</node>\n";
		}
	}
	
	return $xml;
}

function spicynodes_navigator_make_tag_xml($make_navigator_xml=true)
{
	//root node
	/*
	$xml = "<node>\n";
	$xml .= "  <label>\n";
	$xml .= "  <![CDATA[Tags...]]>\n";
	$xml .= "  </label>\n";
	*/
		
	//make for groups
	$grouptag_ids = array();
	$groups = spicynodes_navigator_grouptags_getGroups();
	if ($groups) {
		foreach ($groups as $group) {
			$xml .= "<node>\n";
			$xml .= "  <label>\n";
			$xml .= "  <![CDATA[(".$group["groupName"].")]]>\n";
			$xml .= "  </label>\n";
			
			$xml .= spicynodes_navigator_make_tag_xmli($group["groupTagObjs"]);
			
			$xml .= "</node>\n";
			
			$t = $group["groupTagIds"];
			if ($t) {
				$grouptag_ids = array_merge($grouptag_ids, $t);
			}
		}
		$grouptag_ids = array_unique($grouptag_ids);
	}
	
	if ($groups) {
		//other tags not in groups
		$xml .= "<node>\n";
		$xml .= "  <label>\n";
		$xml .= "  <![CDATA[Tags...]]>\n";
		$xml .= "  </label>\n";
	}
	
	$args = array( 'order' => 'DESC', 'orderby' => 'count' );
	$tags = get_tags($args);
	foreach($tags as $tag) {
		if (!in_array($tag->term_id, $grouptag_ids)) {
			$tags_not_in_groups[] = $tag;
		}
	}
	
	$xml .= spicynodes_navigator_make_tag_xmli($tags_not_in_groups);
	
	if ($groups) {
		$xml .= "  </node>\n"; //other tags not in groups
	}
	
	//$xml .= "</node>\n"; //root node
	
	//
	file_put_contents(SpicyNodes_FileRoot."/xml/tags.xml", $xml);
  
  if ($make_navigator_xml) {
		spicynodes_navigator_make_xml();
	}
}

function spicynodes_navigator_make_related_tags_xml($tag_id)
{	
	$tag_ids = spicynodes_navigator_get_related_tags($tag_id);
	if ($tag_ids) {
		foreach ($tag_ids as $tag_id) {
			$tags[] = get_tag($tag_id);
		}
	}
	/*
	$xml .= "<node>\n";
	$xml .= "  <label>\n";
	$xml .= $tags?"  <![CDATA[Related Tags...]]>\n":"  <![CDATA[No Related Tags]]>\n";
	$xml .= "  </label>\n";
	*/
	$xml = spicynodes_navigator_make_tag_xmli($tags);
	
	//$xml .= "</node>\n"; #Related Tags
	
	return $xml;
}

// For Categories
function spicynodes_navigator_sub_categories($args)
{	
	$categories = get_categories($args);	
	if ($categories) {		
		$i = 0;
		$j = 0;
		$NUM_EACH_LEVEL = SpicyNodes_PerOrbit;
		foreach ($categories as $category){
			$category_label = $category->name." (".$category->count.")";
			$category_link = get_category_link($category->term_id);
		
			if (0 == $i) {
				if ($args['parent'] == 0) { //only for parent nodes
					$xml .= "<node>\n";
					$xml .= "  <label>\n";
					$xml .= "  <![CDATA[Categories...]]>\n";
					$xml .= "  </label>\n";
					$j++;
				}
			} else if (0 == ($i%$NUM_EACH_LEVEL)) {
				$s = $i+1;
				$xml .= "<node>\n";
				$xml .= "  <label>\n";
				$xml .= "  <![CDATA[MORE ($s...)]]>\n";
				$xml .= "  </label>\n";
				$j++;
			}
			
			$xml .= "<node linktext='Show...' type='http' href='${category_link}' >\n";
			$xml .= "  <label>\n";
			$xml .= "  <![CDATA[${category_label}]]>\n";
			$xml .= "  </label>\n";
			
			$t = array( 'order' => $args['order'], 'orderby' => $args['orderby'], 'parent' => (int)$category->cat_ID );
			$xml .= spicynodes_navigator_sub_categories($t);
			
			$xml .= "</node>\n";
			
			$i++;
		}
		
		for (; $j>0; $j--) {
			$xml .= "</node>\n";
		}
	}
	
	return $xml;	
}

function spicynodes_navigator_make_category_xml($make_navigator_xml=true)
{
	$args = array( 'order' => 'DESC', 'orderby' => 'count' );
  $args['parent'] = 0;
	
	$ret = spicynodes_navigator_sub_categories($args);
	
	if ($ret) {
		$xml = $ret;
	} else {
		$xml .= "<node>\n";
		$xml .= "  <label>\n";
		$xml .= "  <![CDATA[No categories yet!]]>\n";
		$xml .= "  </label>\n";
		$xml .= "</node>\n";
	} 
	
	file_put_contents(SpicyNodes_FileRoot."/xml/categories.xml", $xml);
  
  if ($make_navigator_xml) {
		spicynodes_navigator_make_xml();
	}
}

// For Archives
function spicynodes_navigator_sub_archives($args)
{	
	$archives = wp_get_archives($args);
	//no clean api, it depends return format of wp_get_archives
	//which returns currently as:
	//"<li><a href='http://184.106.197.206/wordpress/?m=201007' title='July 2010'>July 2010</a>&nbsp;(8)</li>"
	//under code would fails if the returned lines format changed
	if ($archives) {
		$ss = explode ("</li>", $archives);
		foreach ($ss as $s) {
			if (trim($s)) {
				$a = explode("href='", $s);
				$s = $a[1];
				$a = explode("' title='", $s);
				$link = $a[0];				
				
				$a = explode("'>", $s);
				$s = $a[1];
				$a = explode("</a>", $s);
				
				$s = $a[0];
				$a2 = explode(" ", $s);
				$year = (string)$a2[1];
				$month = (string)$a2[0];
				
				$s = $a[1];
				$a = explode("(", $s);
				$s = $a[1];
				$a = explode(")", $s);
				$count = (string)$a[0];
				
				$as[$year]["$month ($count)"] = $link;
			}
		}
		
		$years = count($as);
		
		if ($years) {
			$i = 0;
			$j = 0;
			$NUM_EACH_LEVEL = SpicyNodes_PerOrbit;
			foreach ($as as $year=>$as2){
				
				if (0 == $i) {
					if ($args['parent'] == 0) { //only for parent nodes
						$xml .= "<node>\n";
						$xml .= "  <label>\n";
						$xml .= "  <![CDATA[Archives...]]>\n";
						$xml .= "  </label>\n";
						$j++;
					}
				} else if (0 == ($i%$NUM_EACH_LEVEL)) {
					$s = $i+1;
					$xml .= "<node>\n";
					$xml .= "  <label>\n";
					$xml .= "  <![CDATA[MORE ($s...)]]>\n";
					$xml .= "  </label>\n";
					$j++;
				}
				
				if ($years >1) {
					$xml .= "<node>\n";
					$xml .= "  <label>\n";
					$xml .= "  <![CDATA[${year}]]>\n";
					$xml .= "  </label>\n";
				}
				
				foreach ($as2 as $month => $link) {
					$xml .= "<node linktext='Show...' type='http' href='${link}' >\n";
					$xml .= "  <label>\n";
					$xml .= "  <![CDATA[${month}]]>\n";
					$xml .= "  </label>\n";
					$xml .= "</node>\n";
				}
				
				if ($years >1) {
					$xml .= "</node>\n";
				}
				
				$i++;
			}
			
			for (; $j>0; $j--) {
				$xml .= "</node>\n";
			}
		} else {
			$xml .= "<node>\n";
			$xml .= "  <label>\n";
			$xml .= "  <![CDATA[No archives yet!]]>\n";
			$xml .= "  </label>\n";
			$xml .= "<node>\n";
		}
	}
	
	return $xml;	
}

function spicynodes_navigator_make_archive_xml($make_navigator_xml=true)
{
	$args = array('type'=>'monthly', 'show_post_count'=>true, 'echo' => 0);
	
	$ret = spicynodes_navigator_sub_archives($args);
	
	if ($ret) {
		$xml = $ret;
	} else {
		$xml .= "<node>\n";
		$xml .= "  <label>\n";
		$xml .= "  <![CDATA[No archives yet!]]>\n";
		$xml .= "  </label>\n";
		$xml .= "</node>\n";
	} 
	
	file_put_contents(SpicyNodes_FileRoot."/xml/archives.xml", $xml);
	
	if ($make_navigator_xml) {
		spicynodes_navigator_make_xml();
	}
}

//
function spicynodes_navigator_make_xml($navigatorFile='navigator.xml', $tagFile='tags.xml')
{
	$options = get_option('spicynodes_navigator');
	
	$archive = htmlspecialchars($options['archive'], ENT_QUOTES);
	$category = htmlspecialchars($options['category'], ENT_QUOTES);
	$tag = htmlspecialchars($options['tag'], ENT_QUOTES);
	
	$has_archive = ("checked" == $archive);
	$has_category = ("checked" == $category);
	$has_tag = ("checked" == $tag);
	$only_archive = ($has_archive && !$has_category && !$has_tag);
	$only_category = ($has_category && !$has_archive && !$has_tag);
	$only_tag = ($has_tag && !$has_category && !$has_archive);
	$hasNothing = (!$has_tag && !$has_category && !$has_archive);
	
	$header =<<<END
	<?php
	include_once SpicyNodes_FileRoot."/../../../../wp-load.php";
	require_once "../navigator.inc.php";
	\$tags = \$_GET["tags"];
	if (\$tags) {
	  \$tags = split(",", \$tags);
	  foreach (\$tags as \$tag_id) {
	    \$tag = get_tag(\$tag_id);
	    \$tag_label = \$tag->name; // ." (".\$tag->count.")";
	    \$tag_link = get_tag_link(\$tag->term_id);
	    \$id = str_pad((string)(\$tag->term_id), 32, "1", STR_PAD_LEFT);
	    \$tags_xml .= "<node linktext='Show...' type='http' href='\${tag_link}' id='\${id}' >\n";
	    \$tags_xml .= "  <label>\n";
	    \$tags_xml .= "  <![CDATA[\${tag_label}]]>\n";
	        \$tags_xml .= "  </label>\n";
	        \$tags_xml .= spicynodes_navigator_make_related_tags_xml(\$tag->term_id);
	        \$tags_xml .= "</node>\n";
	  }
	}
	echo "<?xml version='1.0'?>";
	?>
END;

	//$xml .= $header;

	$xml .= "<nodemap>\n";
	if ($hasNothing) {
		$xml .= "<node>\n";
		$xml .= "  <label>\n";
		$xml .= "  <![CDATA[Not select item yet!]]>\n";
		$xml .= "  </label>\n";
		$xml .= "</node>\n";
	} elseif ($only_archive) {
		$xml .= file_get_contents(SpicyNodes_FileRoot."/xml/archives.xml");
	} elseif ($only_category) {
		$xml .= file_get_contents(SpicyNodes_FileRoot."/xml/categories.xml");
	} elseif ($only_tag) {
		$xml .= file_get_contents(SpicyNodes_FileRoot."/xml/${tagFile}");
	} else {
		$xml .= "<node>\n";
		$xml .= "  <label>\n";
		$xml .= "  <![CDATA[BROWSE...]]>\n";
		$xml .= "  </label>\n";
		if ($has_archive) {
			$xml .= file_get_contents(SpicyNodes_FileRoot."/xml/archives.xml");
		}
		if ($has_category) {
			$xml .= file_get_contents(SpicyNodes_FileRoot."/xml/categories.xml");
		}
		if ($has_tag) {
			$xml .= file_get_contents(SpicyNodes_FileRoot."/xml/${tagFile}");
		}
		$xml .= "</node>\n";
	}
	$xml .= '</nodemap>';
	
	file_put_contents(SpicyNodes_FileRoot."/xml/${navigatorFile}", $xml);
}

function spicynodes_navigator_make_xml_4_post($postId, $createNew=false) {
	$path = SpicyNodes_FileRoot;
	
	$f = "navigator-post-${postId}.xml";
	if (file_exists("$path/xml/$f") && !$createNew) {
		return;
	}
	
	$tags = get_the_tags($postId);
	$xml = spicynodes_navigator_make_tag_xmli($tags);
	$f2 = "tag-post-${postId}.xml";
	file_put_contents("$path/xml/$f2", $xml);
	
	spicynodes_navigator_make_xml($f, $f2);
	
	unlink("$path/xml/$f2");
}

function spicynodes_navigator_make_xml_4_tag($tagId, $createNew=false) {
	$path = SpicyNodes_FileRoot;
	
	$f = "navigator-tag-${tagId}.xml";
	if (file_exists("$path/xml/$f") && !$createNew) {
		return;
	}
	
	$xml = spicynodes_navigator_make_related_tags_xml($tagId);
	$f2 = "tag-tag-${tagId}.xml";
	file_put_contents("$path/xml/$f2", $xml);
	
	spicynodes_navigator_make_xml($f, $f2);
	
	unlink("$path/xml/$f2");
}

function spicynodes_navigator_remake_xml() {
	spicynodes_navigator_make_archive_xml(false);
	spicynodes_navigator_make_category_xml(false);
	spicynodes_navigator_make_tag_xml(false);
	spicynodes_navigator_make_xml();
}

?>